using Newtonsoft.Json;
using System.Net.Http.Headers;
using System.Text;
using VeterinaryContracts.ViewModels;

namespace VeterinaryShowOwnerApp
{
	public static class APIOwner
	{
		private static readonly HttpClient _owner = new();
		public static OwnerViewModel? Owner { get; set; } = null;
		public static void Connect(IConfiguration configuration)
		{
			_owner.BaseAddress = new Uri(configuration["IPAddress"]);
			_owner.DefaultRequestHeaders.Accept.Clear();
			_owner.DefaultRequestHeaders.Accept.Add(new
		   MediaTypeWithQualityHeaderValue("application/json"));
		}
		public static T? GetRequest<T>(string requestUrl)
		{
			var response = _owner.GetAsync(requestUrl);
			var result = response.Result.Content.ReadAsStringAsync().Result;
			if (response.Result.IsSuccessStatusCode)
			{
				return JsonConvert.DeserializeObject<T>(result);
			}
			else
			{
				throw new Exception(result);
			}
		}
		public static void PostRequest<T>(string requestUrl, T model)
		{
			var json = JsonConvert.SerializeObject(model);
			var data = new StringContent(json, Encoding.UTF8, "application/json");
			var response = _owner.PostAsync(requestUrl, data);
			var result = response.Result.Content.ReadAsStringAsync().Result;
			if (!response.Result.IsSuccessStatusCode)
			{
				throw new Exception(result);
			}
		}
	}
}